/**********************************************************************
  Initialize ppcsim system
  $Id: init_system.c,v 1.2 2002/04/29 03:39:13 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"
#include "op_scemu.h"

int init_system()
{
  int i ;
  int res ; 
  
  default_memsize          = DEFAULT_MEMSIZE ;
  default_heaptop          = DEFAULT_HEAPTOP ;
  default_exec_start       = DEFAULT_EXEC_START ;
  default_stack_top_offset = DEFAULT_STACK_TOP_OFFSET ;
  
  init_sighandl_ppcsim() ;
  init_excp() ;
  init_sim_io() ;
  init_op_func_tbl() ;
  
  proc_list.cur_id=-1 ;
  for( i=0 ; i<MAX_PROCESS_ID ; i++ ){
    proc_list.proc[i].mem[0x0]=NULL ;
    proc_list.proc[i].mem_size[0x0]=0 ;
  }
  res=create_proc( &proc_list, 0x10000 ) ; /*** pid=0 𐶐 ***/
  if( res!=NORMAL_EXIT ){
    fprintf(stderr,"sĂ܂\n") ;
    exit(0) ;
  }
  trace.size=DEFAULT_TRACE_SIZE ;
  trace.ptr =0 ;
  trace.buf =malloc( trace.size*sizeof(struct TRACE_BUF_STRUCT) ) ;
  if( trace.buf==NULL ){
    fprintf(stderr,"sĂ܂\n") ;
    exit(0) ;
  }
  for( i=0 ; i<trace.size ; i++ ){
    trace.buf[i].pc  =0xffffffff ;
    trace.buf[i].inst=0x00000000 ;
  }
#ifdef SUPPORT_SYSTEMCALL_EMULATION
  for( i=0 ; i<DIR_ENTRY_MAX ; i++ ){
    dir_list[i].ppc_mem_ptr=0 ;
    dir_list[i].cygwin_DIR =NULL ;
  }
#endif
  iexe_count =  0 ;
  pp_msg     =PP_DUMP_PC ;
  truss_stat =OFF ;
  trace_stat =TRACE_OFF ;
  verbose    =OFF ;
  for( i=0 ; i<MAX_PROCESS_ID ; i++ ){
    proc_list.proc[i].bp_num    = 0 ;
    proc_list.proc[i].bp_id     = 0 ;
    proc_list.proc[i].pp_num    = 0 ;
    proc_list.proc[i].pp_id     = 0 ;
  }
  
  if( simlog==NULL ){
    simmsgfp=DEFAULT_SIMMSG_OUT ;
  }else{
    simmsgfp=fopen( simlog,"wb" ) ;
    if( simmsgfp==NULL ){
      fprintf(stderr,"V~[VO(%s)I[vł܂ł\n",simlog ) ;
      exit(0) ;
    }
  }

  return(NORMAL_EXIT) ;
}  
