/**********************************************************************
  ߃fR[h  bit0-5=0b01xxxx
  $Id: op_1x_func.c,v 1.4 2002/05/12 13:52:27 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"

int op_10_func( struct MACHINE_RESOURCE *mres , int mode ) /* bc,bca,bcl,bcla */
{
  unsigned int bi,bo,ab,lk,adrs ;
  int cc ;
  int branch ;
  branch = NO ;
  adrs= mres->inst & 0x0000fffc ;
  ab  = mres->inst & 0x00000002 ;
  lk  = mres->inst & 0x00000001 ;
  bo  =(mres->inst & 0x03e00000)<<6  ;
  bi  =(mres->inst & 0x001f0000)>>16 ;
  cc  = mres->FLGR.cr[(bi/4)] & (0x80000000>>(bi%4)) ;

  if( DO_EXEC_DIS(mode) ){
    if( lk != 0 ) fputs("l",simmsgfp) ;
    if( ab != 0 ) fputs("a",simmsgfp) ;
    fprintf(simmsgfp,"\t%d,%d,%d\n",bo>>27,bi,adrs) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    switch( (bo & 0xf0000000) ){
    case 0x00000000 :
      mres->FLGR.ctrl-- ;
      if( mres->FLGR.ctrl!=0 && cc==0 ) branch=YES ;
      break ;
    case 0x10000000 :
      mres->FLGR.ctrl-- ;
      if( mres->FLGR.ctrl==0 && cc==0 ) branch=YES ;
      break ;
    case 0x20000000 :
      if( cc==0 ) branch=YES ;
      break ;
    case 0x40000000 :
      mres->FLGR.ctrl-- ;
      if( mres->FLGR.ctrl!=0 && cc!=0 ) branch=YES ;
      break ;
    case 0x50000000 :
      mres->FLGR.ctrl-- ;
      if( mres->FLGR.ctrl==0 && cc!=0 ) branch=YES ;
      break ;
    case 0x60000000 :
      if( cc!=0 ) branch=YES ;
      break ;
    case 0x80000000 :
      mres->FLGR.ctrl-- ;
      if( mres->FLGR.ctrl!=0 ) branch=YES ;
      break ;
    case 0x90000000 :
      mres->FLGR.ctrl-- ;
      if( mres->FLGR.ctrl==0 ) branch=YES ;
      break ;
    case 0xa0000000 :
      branch=YES ;
      break ;
    default :
      return(INVALID_BO) ;
    }
    if( branch==YES ){
      if( lk!=0 ) mres->FLGR.lrl=mres->pc+4 ;
      if( ab==0 ){
	if( (adrs & 0x00008000)!=0 ){
	  adrs = adrs | 0xffff0000 ; //g
	}
	mres->pc += adrs ;
      }else{
	mres->pc  = adrs ;
      }
    }else{
      mres->pc += 4 ;
    }
  }
  
  return(0) ;
}

int op_11_func( struct MACHINE_RESOURCE *mres , int mode ) /* sc */
{
  if( mres->inst!=0x44000002 ){
    if( DO_EXEC_DIS(mode) ){
      fputs("\t/* ignore format */\n",simmsgfp) ;
    }
    return(UNKNOWN_INSTRUCTION) ;
  }
  
  if( DO_EXEC_DIS(mode) ){
    fputs("\n",simmsgfp) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( excp_stat.e0c00.stat == DISABLE ){
      return( op_scemu( mres ) ) ;
    }
    mres->pc += 4 ;
    return(EXCEPTION_SYSCALL) ;
  }
  
  return(0) ;
}


int op_12_func( struct MACHINE_RESOURCE *mres , int mode ) /* b,ba,bl,bla */
{
  unsigned int ab,lk,adrs ;
  
  adrs=mres->inst & 0x03fffffc ;
  ab  =mres->inst & 0x00000002 ;
  lk  =mres->inst & 0x00000001 ;

  if( DO_EXEC_DIS(mode) ){
    if( lk != 0 ){
      fputs("l",simmsgfp) ;
    }else if( ab != 0 ){
      fputs("a",simmsgfp) ;
    }
    fprintf(simmsgfp,"\t%d\n",adrs) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( lk!=0 ) mres->FLGR.lrl=mres->pc+4 ;
    if( ab==0 ){
      if( (adrs & 0x02000000)!=0 ){
	adrs = adrs | 0xfc000000 ; //g
      }
      mres->pc += adrs ;
    }else{
      mres->pc = adrs ;
    }
  }
  
  return(0) ;
}


int op_13_func( struct MACHINE_RESOURCE *mres , int mode ) /* call op_13_subfunc */
{
  int op_dec_bit21to30 ;
  op_dec_bit21to30=(mres->inst & 0x7fe)>>1 ;
  if( DO_EXEC_DIS(mode) ){
    fprintf(simmsgfp,"%s",
	    op_13_subfunc_tbl[op_dec_bit21to30].name) ;
  }
  if( DO_EXEC_INST(mode) ){
    op_13_subfunc_tbl[op_dec_bit21to30].count++ ;
  }
  return( op_13_subfunc_tbl[op_dec_bit21to30].func(mres,mode) ) ;
}

int op_14_func( struct MACHINE_RESOURCE *mres , int mode ) /* rlwimi,rlwimi. */
{
  unsigned int r1,r2 ;
  int	sh,mb,me,updt_cr ;
  int	bitmask_num ;
  unsigned int	bitmask,masktmp ;
  unsigned int	shiftin ; //[e[gœĂrbg
  int	i ;
  
  r1= (mres->inst & 0x03e00000)>>21 ; //rS
  r2= (mres->inst & 0x001f0000)>>16 ; //rA
  sh= (mres->inst & 0x0000f800)>>11 ; //SH or rB
  mb= (mres->inst & 0x000007c0)>>6  ; //MB
  me= (mres->inst & 0x0000003e)>>1  ; //ME
  updt_cr= (mres->inst & 0x00000001)  ; //update_cr

  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ){
      fputs(".",simmsgfp) ;
    }
    dis_print_rrddd(simmsgfp,r1,r2,sh,mb,me) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( me<mb ){
      /** MBME傫ꍇ́AWX^bitwrapă}XN𐶐B **/
      bitmask_num=mb-me-1 ;
      masktmp=0x80000000>>((me+1)%32) ;
      for( i=0,bitmask=0 ; i<bitmask_num ; i++,masktmp>>=1 ){
	bitmask |= masktmp ;
      }
      bitmask = ~bitmask ;
    }else{
      bitmask_num=me-mb+1 ;
      masktmp=0x80000000>>mb ;
      for( i=0,bitmask=0 ; i<bitmask_num ; i++,masktmp>>=1 ){
	bitmask |= masktmp ;
      }
    }
    shiftin=mres->GPR[r1].rl>>(32-sh) ;
    mres->GPR[r2].rl = mres->GPR[r2].rl & ~bitmask ; // (1)Zbg
    mres->GPR[r2].rl = mres->GPR[r2].rl | (((mres->GPR[r1].rl<<sh) | shiftin) & bitmask) ; //(2)Zbg
    if( updt_cr!=0 ) update_cr( mres->GPR[r2].rl ) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}

int op_15_func( struct MACHINE_RESOURCE *mres , int mode ) /* rlwinmi,rlwinmi. */
{
  unsigned int r1,r2 ;
  int	sh,mb,me,updt_cr ;
  int	bitmask_num ;
  unsigned int	bitmask,masktmp ;
  unsigned int	shiftin ; //[e[gœĂrbg
  int	i ;

  r1= (mres->inst & 0x03e00000)>>21 ; //rS
  r2= (mres->inst & 0x001f0000)>>16 ; //rA
  sh= (mres->inst & 0x0000f800)>>11 ; //SH or rB
  mb= (mres->inst & 0x000007c0)>>6  ; //MB
  me= (mres->inst & 0x0000003e)>>1  ; //ME
  updt_cr= (mres->inst & 0x00000001)  ; //update_cr

  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ){
      fputs(".",simmsgfp) ;
    }
    dis_print_rrddd(simmsgfp,r1,r2,sh,mb,me) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( me<mb ){
      /** MBME傫ꍇ́AWX^bitwrapă}XN𐶐B **/
      bitmask_num=mb-me-1 ;
      masktmp=0x80000000>>((me+1)%32) ;
      for( i=0,bitmask=0 ; i<bitmask_num ; i++,masktmp>>=1 ){
	bitmask |= masktmp ;
      }
      bitmask = ~bitmask ;
    }else{
      bitmask_num=me-mb+1 ;
      masktmp=0x80000000>>mb ;
      for( i=0,bitmask=0 ; i<bitmask_num ; i++,masktmp>>=1 ){
	bitmask |= masktmp ;
      }
    }
    
    shiftin=mres->GPR[r1].rl>>(32-sh) ;
    mres->GPR[r2].rl = ((mres->GPR[r1].rl<<sh) | shiftin) & bitmask ;
    if( updt_cr!=0 ) update_cr( mres->GPR[r2].rl ) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}

int op_17_func( struct MACHINE_RESOURCE *mres , int mode ) /* rlwnm,rlwnm. */
{
  unsigned int r1,r2 ;
  int	sh,mb,me,updt_cr ;
  int	bitmask_num ;
  unsigned int	bitmask,masktmp ;
  unsigned int	shiftin ; //[e[gœĂrbg
  int	i ;
  
  r1= (mres->inst & 0x03e00000)>>21 ; //rS
  r2= (mres->inst & 0x001f0000)>>16 ; //rA
  sh= (mres->inst & 0x0000f800)>>11 ; //SH or rB
  mb= (mres->inst & 0x000007c0)>>6  ; //MB
  me= (mres->inst & 0x0000003e)>>1  ; //ME
  updt_cr= (mres->inst & 0x00000001)  ; //update_cr

  if( DO_EXEC_DIS(mode) ){
    if( updt_cr!=0 ){
      fputs(".",simmsgfp) ;
    }
    dis_print_rrddd(simmsgfp,r1,r2,sh,mb,me) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( me<mb ){
      /** MBME傫ꍇ́AWX^bitwrapă}XN𐶐B **/
      bitmask_num=mb-me-1 ;
      masktmp=0x80000000>>((me+1)%32) ;
      for( i=0,bitmask=0 ; i<bitmask_num ; i++,masktmp>>=1 ){
	bitmask |= masktmp ;
      }
      bitmask = ~bitmask ;
    }else{
      bitmask_num=me-mb+1 ;
      masktmp=0x80000000>>mb ;
      for( i=0,bitmask=0 ; i<bitmask_num ; i++,masktmp>>=1 ){
	bitmask |= masktmp ;
      }
    }
    
    // mres->GPR[sh].rl̉6bit炵 32bitCvgł5bit̂ƓH
    shiftin=mres->GPR[r1].rl>>(32-(mres->GPR[sh].rl & 0x0000001f)) ;
    mres->GPR[r2].rl = ((mres->GPR[r1].rl<<(mres->GPR[sh].rl & 0x0000001f)) | shiftin) & bitmask ;
    if( updt_cr!=0 ) update_cr( mres->GPR[r2].rl ) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_18_func( struct MACHINE_RESOURCE *mres , int mode ) /* ori */
{
  unsigned int	r1,r2 ;
  unsigned int	uimm ;
  
  r1= (mres->inst & 0x03e00000)>>21 ; //rS
  r2= (mres->inst & 0x001f0000)>>16 ; //rA
  uimm = (mres->inst & 0x0000ffff) ;

  if( DO_EXEC_DIS(mode) ){
    dis_print_rri(simmsgfp,r2,r1,uimm) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r2].rl = mres->GPR[r1].rl | uimm ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_19_func( struct MACHINE_RESOURCE *mres , int mode ) /* oris */
{
  unsigned int	r1,r2 ;
  unsigned int	uimm ;
  
  r1= (mres->inst & 0x03e00000)>>21 ; //rS
  r2= (mres->inst & 0x001f0000)>>16 ; //rA
  uimm = (mres->inst & 0x0000ffff) ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rri(simmsgfp,r2,r1,uimm) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r2].rl = mres->GPR[r1].rl | (uimm<<16) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}

int op_1a_func( struct MACHINE_RESOURCE *mres , int mode ) /* xori */
{
  unsigned int	r1,r2 ;
  unsigned int	uimm ;
  
  r1= (mres->inst & 0x03e00000)>>21 ; //rS
  r2= (mres->inst & 0x001f0000)>>16 ; //rA
  uimm = (mres->inst & 0x0000ffff) ;

  if( DO_EXEC_DIS(mode) ){
    dis_print_rri(simmsgfp,r2,r1,uimm) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r2].rl = mres->GPR[r1].rl ^ uimm ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1b_func( struct MACHINE_RESOURCE *mres , int mode ) /* xoris */
{
  unsigned int	r1,r2 ;
  unsigned int	uimm ;
  
  r1= (mres->inst & 0x03e00000)>>21 ; //rS
  r2= (mres->inst & 0x001f0000)>>16 ; //rA
  uimm = (mres->inst & 0x0000ffff) ;

  if( DO_EXEC_DIS(mode) ){
    dis_print_rri(simmsgfp,r2,r1,uimm) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r2].rl = mres->GPR[r1].rl ^ (uimm<<16) ;
    mres->pc+=4 ;
  }

  return(0) ;
}

int op_1c_func( struct MACHINE_RESOURCE *mres , int mode ) /* andi. */
{
  unsigned int	r1,r2 ;
  unsigned int	uimm ;
  
  r1= (mres->inst & 0x03e00000)>>21 ; //rS
  r2= (mres->inst & 0x001f0000)>>16 ; //rA
  uimm = (mres->inst & 0x0000ffff) ;

  if( DO_EXEC_DIS(mode) ){
    dis_print_rri(simmsgfp,r2,r1,uimm) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r2].rl = mres->GPR[r1].rl & uimm ;
    update_cr( mres->GPR[r2].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}

int op_1d_func( struct MACHINE_RESOURCE *mres , int mode ) /* andis. */
{
  unsigned int	r1,r2 ;
  unsigned int	uimm ;
  
  r1= (mres->inst & 0x03e00000)>>21 ; //rS
  r2= (mres->inst & 0x001f0000)>>16 ; //rA
  uimm = (mres->inst & 0x0000ffff) ;
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rri(simmsgfp,r2,r1,uimm) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    mres->GPR[r2].rl = mres->GPR[r1].rl & (uimm<<16) ;
    update_cr( mres->GPR[r2].rl ) ;
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_1f_func( struct MACHINE_RESOURCE *mres , int mode ) /* call op_1f_subfunc */
{
  int op_dec_bit21to30 ;
  op_dec_bit21to30=(mres->inst & 0x7fe)>>1 ;

  if( DO_EXEC_DIS(mode) ){
    fprintf(simmsgfp,"%s",
	    op_1f_subfunc_tbl[op_dec_bit21to30].name) ;
  }
  if( DO_EXEC_INST(mode) ){
    op_1f_subfunc_tbl[op_dec_bit21to30].count++ ;
  }
  return( op_1f_subfunc_tbl[op_dec_bit21to30].func(mres,mode) ) ;
}
